/*
 * Created on Apr 10, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.imaginot.chess;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;

import chesspresso.*;
import chesspresso.position.*;
import java.util.*;

import java.util.List;

/**
 * @author dkappe
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class MateTest extends JPanel {
	private int totalQuestions = 0;
	private int totalRight = 0;

	private JEditorPane sqr = new JEditorPane();
	private JLabel score = new JLabel("");
	private JLabel status = new JLabel("Good Luck");

	private RandomMateGenerator mg[], mg2[];
	private RandomAlmostMateGenerator amg[], amg2[];
	private Position pos;

	class NoAction extends AbstractAction {
		public NoAction() {
			super("No");
		}
		/* (non-Javadoc)
		 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
		 */
		public void actionPerformed(ActionEvent e) {
			checkResult(false);
		}

	}

	class YesAction extends AbstractAction {

		public YesAction() {
			super("Yes");
		}
		/* (non-Javadoc)
		 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
		 */
		public void actionPerformed(ActionEvent e) {
			checkResult(true);
		}

	}

	private void checkResult(boolean isSame) {
		String relation = (pos.isMate()) ? "was mate." : "was not mate.";
		if (isSame == pos.isMate()) {
			totalRight++;
			status.setText("Correct, the last position " + relation);
			status.setForeground(Color.BLACK);
		} else {
			status.setText("Wrong! The last position " + relation);
			status.setForeground(Color.RED);
		}
		showScore();
		nextPosition();
	}

	private void showScore() {
		if (totalQuestions == 0) {
			score.setText("Score: N/A");
		} else {
			int percent = (100 * totalRight / totalQuestions);
			score.setText(
				"Score: "
					+ percent
					+ "% ("
					+ totalRight
					+ " of "
					+ totalQuestions
					+ ")");
		}
	}

	private void nextPosition() {
		int choice = Square.rand(10);
		if (Math.random() > 0.5) {
			if (Math.random() > 0.5) {
				pos = mg[choice].genPosition();
			} else {
				pos = mg2[choice].genPosition();
			}
		} else {
			if (Math.random() > 0.5) {
				pos = amg[choice].genPosition();
			} else {
				pos = amg2[choice].genPosition();
			}
		}
		totalQuestions++;
		sqr.setText("Is this mate?<br>\n" + PositionDescriber.describeHtml(pos));
	}

	public MateTest() {
		super();

		sqr.setEditable(false);
		sqr.setEnabled(false);
		sqr.setContentType("text/html");
		sqr.setPreferredSize(new Dimension(300, 150));
		sqr.setBorder(new LineBorder(Color.BLACK));

		// set ten or so different pawn positions
		Position pawns[] = new Position[10];
		pawns[0] = new Position(); // empty
		pawns[1] = new Position();
		pawns[1].setStone(Chess.H7,Chess.WHITE_PAWN);
		pawns[2] = new Position();
		pawns[2].setStone(Chess.A7,Chess.BLACK_PAWN);
		pawns[2].setStone(Chess.A6,Chess.WHITE_PAWN);
		pawns[3] = new Position();
		pawns[3].setStone(Chess.H6,Chess.BLACK_PAWN);
		pawns[3].setStone(Chess.G5,Chess.BLACK_PAWN);
		pawns[3].setStone(Chess.G4,Chess.WHITE_PAWN);
		pawns[3].setStone(Chess.F3,Chess.WHITE_PAWN);
		pawns[4] = new Position();
		pawns[4].setStone(Chess.H7,Chess.BLACK_PAWN);
		pawns[4].setStone(Chess.G6,Chess.BLACK_PAWN);
		pawns[4].setStone(Chess.F6,Chess.BLACK_PAWN);
		pawns[4].setStone(Chess.F4,Chess.WHITE_PAWN);
		pawns[4].setStone(Chess.G3,Chess.WHITE_PAWN);
		pawns[4].setStone(Chess.H2,Chess.WHITE_PAWN);
		pawns[5] = new Position();
		pawns[5].setStone(Chess.H7,Chess.BLACK_PAWN);
		pawns[5].setStone(Chess.G6,Chess.BLACK_PAWN);
		pawns[5].setStone(Chess.F7,Chess.BLACK_PAWN);
		pawns[5].setStone(Chess.A4,Chess.BLACK_PAWN);
		pawns[5].setStone(Chess.F4,Chess.WHITE_PAWN);
		pawns[5].setStone(Chess.G3,Chess.WHITE_PAWN);
		pawns[5].setStone(Chess.H4,Chess.WHITE_PAWN);
		pawns[5].setStone(Chess.A3,Chess.WHITE_PAWN);
		pawns[6] = new Position();
		pawns[6].setStone(Chess.D4,Chess.BLACK_PAWN);
		pawns[6].setStone(Chess.E5,Chess.BLACK_PAWN);
		pawns[6].setStone(Chess.D3,Chess.WHITE_PAWN);
		pawns[6].setStone(Chess.E4,Chess.WHITE_PAWN);
		pawns[7] = new Position();
		pawns[7].setStone(Chess.E2,Chess.BLACK_PAWN);
		pawns[7].setStone(Chess.F3,Chess.BLACK_PAWN);
		pawns[7].setStone(Chess.F2,Chess.WHITE_PAWN);
		pawns[7].setStone(Chess.H3,Chess.WHITE_PAWN);
		pawns[8] = new Position();
		pawns[8].setStone(Chess.E5,Chess.BLACK_PAWN);
		pawns[8].setStone(Chess.E4,Chess.WHITE_PAWN);
		pawns[9] = new Position();
		pawns[9].setStone(Chess.G5,Chess.BLACK_PAWN);
		pawns[9].setStone(Chess.F5,Chess.BLACK_PAWN);
		pawns[9].setStone(Chess.G4,Chess.WHITE_PAWN);
		pawns[9].setStone(Chess.F4,Chess.WHITE_PAWN);
		
		
		List l = new ArrayList();
		l.add(new Integer(Chess.WHITE_KING));
		l.add(new Integer(Chess.WHITE_ROOK));
		l.add(new Integer(Chess.BLACK_KING));
		l.add(new Integer(Chess.BLACK_KNIGHT));
		mg = new RandomMateGenerator[10];
		amg = new RandomAlmostMateGenerator[10];
		
		for (int i = 0; i < 10; i++) {
			mg[i] = new RandomMateGenerator(l, false,pawns[i]);
			amg[i] = new RandomAlmostMateGenerator(l, false, pawns[i]);
		}
		
		
		l = new ArrayList();
		l.add(new Integer(Chess.WHITE_KING));
		l.add(new Integer(Chess.WHITE_QUEEN));
		l.add(new Integer(Chess.BLACK_KING));
		l.add(new Integer(Chess.BLACK_BISHOP));
		l.add(new Integer(Chess.BLACK_KNIGHT));

		mg2 = new RandomMateGenerator[10];
		amg2 = new RandomAlmostMateGenerator[10];
		
		for (int i = 0; i < 10; i++) {
			mg2[i] = new RandomMateGenerator(l, false,pawns[i]);
			amg2[i] = new RandomAlmostMateGenerator(l, false, pawns[i]);
		}

		setLayout(new GridBagLayout());
		GridBagConstraints gbc = new GridBagConstraints();

		gbc.insets = new Insets(10, 10, 10, 10);
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.gridwidth = 3;

		add(status, gbc);

		gbc.gridy = 1;

		add(sqr, gbc);

		JToolBar jtp = new JToolBar();
		jtp.setFloatable(false);

		jtp.add(new YesAction());
		jtp.add(new NoAction());

		gbc.gridx = 0;
		gbc.gridy = 2;
		gbc.gridwidth = 3;

		add(jtp, gbc);

		gbc.gridx = 0;
		gbc.gridy = 3;
		gbc.gridwidth = 3;

		add(score, gbc);

		showScore();
		nextPosition();

	}
}
