/*
 * Created on Apr 10, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.imaginot.chess;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

import com.imaginot.chess.swing.*;
import com.imaginot.chess.engine.*;

//import foxtrot.*;

/**
 * @author dkappe
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class PlayTest extends JPanel {

	private ChessBoard board;
	private ChessBoardModel model;
	private ChessEngine engine;
	private MoveAction makeMove;
	private ResetAction resetAction;
	private JLabel status;
	private JTextField moveEntry;
	private JComboBox side;
	private JComboBox plySelect;
	private int ply = 0;
	private DefaultListModel moveList;
	private JList moveDisplay;
	private JScrollPane jsp;

	public PlayTest() {
		super();
		setLayout(new GridBagLayout());

		JLabel temp;
		GridBagConstraints gbc = new GridBagConstraints();

		gbc.insets = new Insets(2, 2, 2, 2);

		engine = new SimpleEngine();

		model = new GenericChessBoardModel();
		model.updateBoard(engine.getBoard(ply));
		board = new ChessBoard(model);

		temp = new JLabel("Hide:");
		gbc.gridx = 3;
		gbc.gridy = 0;
		gbc.gridwidth = 2;
		gbc.gridheight = 1;
		add(temp, gbc);

		JToolBar jtp = new JToolBar();
		jtp.setFloatable(false);
		jtp.setLayout(new GridLayout(3, 2));

		//jtp.add(new FlipAction());
		jtp.add(new JCheckBox(new NWAction()));
		jtp.add(new JCheckBox(new NEAction()));
		jtp.add(new JCheckBox(new SWAction()));
		jtp.add(new JCheckBox(new SEAction()));
		jtp.add(new JCheckBox(new PawnAction()));
		jtp.add(new JCheckBox(new PieceAction()));
		jtp.setBorder(new LineBorder(Color.BLACK));

		gbc.gridx = 3;
		gbc.gridy = 1;
		gbc.gridwidth = 2;
		gbc.gridheight = 1;
		add(jtp, gbc);

		//temp = new JLabel("Status:");
		//gbc.gridx = 0;
		//gbc.gridy = 5;
		//gbc.gridwidth = 1;
		//gbc.gridheight = 1;
		//add(temp, gbc);

		moveEntry = new JTextField(6);
		moveEntry.setPreferredSize(
			new Dimension(35, moveEntry.getPreferredSize().height));
		moveEntry.setMinimumSize(
			new Dimension(35, moveEntry.getPreferredSize().height));
		moveEntry.setBorder(new LineBorder(Color.BLACK));
		gbc.gridx = 0;
		gbc.gridy = 8;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		add(moveEntry, gbc);

		makeMove = new MoveAction();
		JButton mm = new JButton(makeMove);
		gbc.gridx = 1;
		gbc.gridy = 8;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		add(mm, gbc);

		// now let the return in the move entry trigger the moveaction
		moveEntry.getActionMap().put("makemove", makeMove);
		moveEntry.getInputMap(WHEN_FOCUSED).put(
			KeyStroke.getKeyStroke("ENTER"),
			"makemove");

		resetAction = new ResetAction();
		JButton reset = new JButton(resetAction);
		gbc.gridx = 2;
		gbc.gridy = 8;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		add(reset, gbc);

		plySelect = new JComboBox();
		plySelect.addActionListener(new PlyAction());
		plySelect.addItem(new Integer(0));
		plySelect.addItem(new Integer(1));
		plySelect.addItem(new Integer(2));
		plySelect.addItem(new Integer(3));
		plySelect.addItem(new Integer(4));
		plySelect.addItem(new Integer(5));
		plySelect.addItem(new Integer(6));
		plySelect.addItem(new Integer(7));

		temp = new JLabel("Ply Lag: ");
		gbc.gridx = 3;
		gbc.gridy = 2;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		add(temp, gbc);

		gbc.gridx = 4;
		gbc.gridy = 2;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		add(plySelect, gbc);

		side = new JComboBox();
		side.addActionListener(new FlipAction());
		side.addItem("white");
		side.addItem("black");

		temp = new JLabel("Human: ");
		gbc.gridx = 3;
		gbc.gridy = 3;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		add(temp, gbc);

		gbc.gridx = 4;
		gbc.gridy = 3;
		gbc.gridwidth = 1;
		gbc.gridheight = 1;
		add(side, gbc);

		gbc.gridx = 3;
		gbc.gridy = 4;
		gbc.gridwidth = 2;
		gbc.gridheight = 1;
		add(new JLabel("moves:"), gbc);

		moveList = new DefaultListModel();
		moveDisplay = new JList(moveList);
		moveDisplay.setFixedCellHeight(12);

		moveDisplay.setFont(new Font("Sans-Serif", Font.PLAIN, 10));
		jsp = new JScrollPane(moveDisplay);
		jsp.setBorder(BorderFactory.createLineBorder(Color.BLACK));
		jsp.setPreferredSize(new Dimension(90, 130));
		jsp.setMinimumSize(new Dimension(90, 130));
		gbc.gridx = 3;
		gbc.gridy = 5;
		gbc.gridwidth = 2;
		gbc.gridheight = 8;
		add(jsp, gbc);

		// finally, add the board
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.gridwidth = 3;
		gbc.gridheight = 7;
		//gbc.weightx = 0.30;
		//gbc.weighty = 0.30;
		add(board, gbc);

		status = new JLabel("Ready");
		status.setMinimumSize(
			new Dimension(258, status.getPreferredSize().height));
		status.setPreferredSize(
			new Dimension(258, status.getPreferredSize().height));
		status.setBorder(new LineBorder(Color.BLACK));
		gbc.gridx = 0;
		gbc.gridy = 7;
		gbc.gridwidth = 3;
		gbc.gridheight = 1;
		add(status, gbc);

	}

	public class FlipAction extends AbstractAction {
		public FlipAction() {
			super("Flip");
		}
		/* (non-Javadoc)
		 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
		 */
		public void actionPerformed(ActionEvent e) {
			JComboBox cb = (JComboBox) e.getSource();
			if (((String) cb.getSelectedItem()).equals("black")) {
				board.setWhiteBottom(false);
			} else {
				board.setWhiteBottom(true);
			}
			if (engine.isWhiteTurn() && board.getWhiteBottom()) {
				// user's turn
				if (!(engine.isDraw() || engine.isMate())) {
					moveEntry.setEnabled(true);
					makeMove.setEnabled(true);
				}
				moveEntry.setText("");
				side.setEnabled(true);
				plySelect.setEnabled(true);
			} else {
				String result = makeEngineMove();
			}
		}

	}

	public class PlyAction extends AbstractAction {
		public PlyAction() {
			super("Ply");
		}
		/* (non-Javadoc)
		 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
		 */
		public void actionPerformed(ActionEvent e) {
			JComboBox cb = (JComboBox) e.getSource();
			ply = ((Integer) cb.getSelectedItem()).intValue();
			//System.err.println("ply = " + ply);
			model.updateBoard(engine.getBoard(ply));
		}

	}

	public class NWAction extends AbstractAction {
		public NWAction() {
			super("NW");
		}
		/* (non-Javadoc)
		 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
		 */
		public void actionPerformed(ActionEvent e) {
			board.setHideNW(!board.isHideNW());
		}

	}

	public class NEAction extends AbstractAction {
		public NEAction() {
			super("NE");
		}
		/* (non-Javadoc)
		 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
		 */
		public void actionPerformed(ActionEvent e) {
			board.setHideNE(!board.isHideNE());
		}

	}
	public class SWAction extends AbstractAction {
		public SWAction() {
			super("SW");
		}
		/* (non-Javadoc)
		 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
		 */
		public void actionPerformed(ActionEvent e) {
			board.setHideSW(!board.isHideSW());
		}

	}
	public class SEAction extends AbstractAction {
		public SEAction() {
			super("SE");
		}
		/* (non-Javadoc)
		 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
		 */
		public void actionPerformed(ActionEvent e) {
			board.setHideSE(!board.isHideSE());
		}

	}

	public class PawnAction extends AbstractAction {
		public PawnAction() {
			super("Pawns");
		}
		/* (non-Javadoc)
		 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
		 */
		public void actionPerformed(ActionEvent e) {
			board.setHidePawns(!board.isHidePawns());
		}

	}

	public class PieceAction extends AbstractAction {
			public PieceAction() {
				super("Pieces");
			}
			/* (non-Javadoc)
			 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
			 */
			public void actionPerformed(ActionEvent e) {
				board.setHidePieces(!board.isHidePieces());
			}

		}
		
	public class ResetAction extends AbstractAction {
		public ResetAction() {
			super("New Game");
		}
		/* (non-Javadoc)
		 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
		 */
		public void actionPerformed(ActionEvent e) {
			engine.reset();
			moveList.removeAllElements();

			if (board.getWhiteBottom()) {
				moveEntry.setEnabled(true);
				makeMove.setEnabled(true);
				moveEntry.setText("");
				status.setText("Good luck!");
				side.setEnabled(true);
				plySelect.setEnabled(true);
				model.updateBoard(engine.getBoard(ply));
				moveEntry.requestFocus();
			} else {
				makeEngineMove();
			}
		}

	}

	public class MoveAction extends AbstractAction {
		public MoveAction() {
			super("Move");
		}
		/* (non-Javadoc)
		 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
		 */
		public void actionPerformed(ActionEvent e) {

			String result = makeUserMove(moveEntry.getText());
			if (!result.startsWith("ERROR")) {
				result = makeEngineMove();
			}
		}

	}
	private String makeUserMove(String move) {
		moveEntry.setEnabled(false);
		makeMove.setEnabled(false);
		side.setEnabled(false);
		plySelect.setEnabled(false);
		resetAction.setEnabled(false);
		String result = engine.makeMove(move);
		status.setText(result);
		if (result.startsWith("ERROR")) {
			if (!(engine.isDraw() || engine.isMate())) {
				moveEntry.setEnabled(true);
				makeMove.setEnabled(true);
			}
			moveEntry.setText("");
			side.setEnabled(true);
			plySelect.setEnabled(true);
			resetAction.setEnabled(true);
			moveEntry.requestFocus();
		} else {
			model.updateBoard(engine.getBoard(ply));
		}
		int plyN = engine.currentPly();
		if (plyN > moveList.size()) {
			if ((plyN % 2) == 0) {
				moveList.addElement("    " + engine.lastMove());
			} else {
				moveList.addElement(
					((int) (plyN / 2) + 1) + ". " + engine.lastMove());
			}
			moveDisplay.ensureIndexIsVisible(moveList.size() - 1);
		}
		//board.paintImmediately(board.getBounds());
		board.repaint();
		try {
			Thread.sleep(500);
		} catch (Exception ignore) {
		}
		return result;
	}

	private String makeEngineMove() {
		moveEntry.setEnabled(false);
		makeMove.setEnabled(false);
		side.setEnabled(false);
		plySelect.setEnabled(false);
		resetAction.setEnabled(false);

		String result;

		status.setText("Thinking...");
		this.paintImmediately(status.getBounds());

		/*
		result = (String) Worker.post(new Job() {
			public Object run() {
				return engine.go();
			}
		});
		*/
		result = engine.go();
		status.setText(result);
		int plyN = engine.currentPly();
		if (plyN > moveList.size()) {
			if ((plyN % 2) == 0) {
				moveList.addElement("    " + engine.lastMove());
			} else {
				moveList.addElement(
					((int) (plyN / 2) + 1) + ". " + engine.lastMove());
			}
			moveDisplay.ensureIndexIsVisible(moveList.size() - 1);
		}
		if (!(engine.isDraw() || engine.isMate())) {
			moveEntry.setEnabled(true);
			makeMove.setEnabled(true);
		}
		moveEntry.setText("");
		side.setEnabled(true);
		plySelect.setEnabled(true);
		resetAction.setEnabled(true);
		model.updateBoard(engine.getBoard(ply));
		moveEntry.requestFocus();
		return result;
	}
}
