/*
 * Created on Apr 20, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.imaginot.chess;

import chesspresso.position.*;
import chesspresso.*;
import java.util.*;

/**
 * @author Administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class PositionDescriber {

	public static String describe(Position p) {
		StringBuffer mesg = new StringBuffer("");

		StringBuffer black, white;
		white = new StringBuffer("White: ");
		black = new StringBuffer("Black: ");

		char file, rank;
		List wk, wq, wr, wn, wb, wp;
		List bk, bq, br, bn, bb, bp;

		wk = new ArrayList();
		wq = new ArrayList();
		wr = new ArrayList();
		wb = new ArrayList();
		wn = new ArrayList();
		wp = new ArrayList();

		bk = new ArrayList();
		bq = new ArrayList();
		br = new ArrayList();
		bb = new ArrayList();
		bn = new ArrayList();
		bp = new ArrayList();

		for (int i = 0; i < 8; i++) {
			for (int j = 0; j < 8; j++) {
				String sq = "" + (char) ('a' + i) + (j + 1);
				switch (p.getStone(i + (8 * j))) {
					case Chess.BLACK_BISHOP :
						bb.add(sq);
						break;
					case Chess.WHITE_BISHOP :
						wb.add(sq);
						break;
					case Chess.BLACK_KNIGHT :
						bn.add(sq);
						break;
					case Chess.WHITE_KNIGHT :
						wn.add(sq);
						break;
					case Chess.BLACK_ROOK :
						br.add(sq);
						break;
					case Chess.WHITE_ROOK :
						wr.add(sq);
						break;
					case Chess.BLACK_QUEEN :
						bq.add(sq);
						break;
					case Chess.WHITE_QUEEN :
						wq.add(sq);
						break;
					case Chess.BLACK_KING :
						bk.add(sq);
						break;
					case Chess.WHITE_KING :
						wk.add(sq);
						break;
					case Chess.BLACK_PAWN :
						bp.add(sq);
						break;
					case Chess.WHITE_PAWN :
						wp.add(sq);
						break;
					default :
						// do nothing
				}
			}
		}

		if (wk.size() > 0) {
			white.append("K " + join(wk));
		}
		if (wq.size() > 0) {
			white.append(", Q " + join(wq));
		}
		if (wr.size() > 0) {
			white.append(", R " + join(wr));
		}
		if (wb.size() > 0) {
			white.append(", B " + join(wb));
		}
		if (wn.size() > 0) {
			white.append(", N " + join(wn));
		}
		if (wp.size() > 0) {
			white.append(", P " + join(wp));
		}

		if (bk.size() > 0) {
			black.append("K " + join(bk));
		}
		if (bq.size() > 0) {
			black.append(", Q " + join(bq));
		}
		if (br.size() > 0) {
			black.append(", R " + join(br));
		}
		if (bb.size() > 0) {
			black.append(", B " + join(bb));
		}
		if (bn.size() > 0) {
			black.append(", N " + join(bn));
		}
		if (bp.size() > 0) {
			black.append(", P " + join(bp));
		}

		mesg.append(white + "\n");
		mesg.append(black + "\n");

		if (Position.isWhiteToPlay(p.getHashCode())) {
			mesg.append("White to move");
		} else {
			mesg.append("Black to move");
		}
		return mesg.toString();
	}

	public static String describeHtml(Position p) {
		return "<pre>\n" + describe(p) + "\n</pre>\n";
	}
	
	public static String join(List l) {
		StringBuffer b = new StringBuffer("");
		Iterator it = l.iterator();
		boolean first = true;

		while (it.hasNext()) {
			String s = (String) it.next();
			if (first) {
				first = false;
				b.append(s);
			} else {
				b.append(", ");
				b.append(s);
			}
		}
		return b.toString();
	}
}
