/*
 * Created on Apr 10, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.imaginot.chess;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

/**
 * @author dkappe
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class SquareColorTest extends JPanel {
	private int totalQuestions = 0;
	private int totalRight = 0;

	private Square current = new Square();
	private JLabel status = new JLabel("Good Luck!");
	private JLabel score = new JLabel("");
	private JLabel sqr = new JLabel("");

	public class BlackAction extends AbstractAction {
		public BlackAction() {
			super("Black");
		}
		/* (non-Javadoc)
		 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
		 */
		public void actionPerformed(ActionEvent e) {
			checkResult(false);
		}

	}

	public class WhiteAction extends AbstractAction {

		public WhiteAction() {
			super("White");
		}
		/* (non-Javadoc)
		 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
		 */
		public void actionPerformed(ActionEvent e) {
			checkResult(true);
		}

	}

	private void checkResult(boolean isWhite) {
		if (isWhite == current.isWhite()) {
			totalRight++;
			status.setText(
				"Correct, " + current + " is " + current.colorName());
			status.setForeground(Color.BLACK);
		} else {
			status.setText("Wrong! " + current + " is " + current.colorName());
			status.setForeground(Color.RED);
		}
		showScore();
		nextSquare();
	}

	private void showScore() {
		if (totalQuestions == 0) {
			score.setText("Score: N/A");
		} else {
			int percent = (100 * totalRight / totalQuestions);
			score.setText(
				"Score: "
					+ percent
					+ "% ("
					+ totalRight
					+ " of "
					+ totalQuestions
					+ ")");
		}
	}

	private void nextSquare() {
		current = current.genInstance();
		totalQuestions++;
		sqr.setText("What color is " + current.toString() + "?");
	}
	public SquareColorTest() {
		super();
		setLayout(new GridBagLayout());
		GridBagConstraints gbc = new GridBagConstraints();

		gbc.insets = new Insets(10, 10, 10, 10);
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.gridwidth = 3;

		add(status, gbc);

		gbc.gridy = 1;

		add(sqr, gbc);

		JToolBar jtp = new JToolBar();
		jtp.setFloatable(false);

		JButton wb = new JButton(new WhiteAction());
		JButton bb = new JButton(new BlackAction());
		jtp.add(wb);
		jtp.add(bb);
		Dimension temp = new Dimension(70, 25);
		wb.setMinimumSize(temp);
		wb.setPreferredSize(temp);
		bb.setMinimumSize(temp);
		bb.setPreferredSize(temp);
		gbc.gridx = 0;
		gbc.gridy = 2;
		gbc.gridwidth = 3;

		add(jtp, gbc);

		gbc.gridx = 0;
		gbc.gridy = 3;
		gbc.gridwidth = 3;

		add(score, gbc);

		showScore();
		nextSquare();

	}
}
