/*
 * Created on Mar 16, 2004
 *
 * Changes the look and feel of a frame.
 * 
 * Supports Metal, Windows and Motif.
 */
package com.imaginot.swing;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

/**
 * @author Administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class LnFListener implements ActionListener {
	Frame frame;
	
	public LnFListener(Frame f) {
		frame = f;
	}
	
	
	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent ae) {
		String lnfName = null;
		String ename = ae.getActionCommand();
		if (ename.equals("Metal")) {
			lnfName = "javax.swing.plaf.metal.MetalLookAndFeel";
		} else if (ename.equals("Motif")) {
			lnfName = "com.sun.java.swing.plaf.motif.MotifLookAndFeel";
		} else if (ename.equals("Windows")) {
			lnfName = "com.sun.java.swing.plaf.windows.WindowsLookAndFeel";
		}
		
		try {
			UIManager.setLookAndFeel(lnfName);
			SwingUtilities.updateComponentTreeUI(frame);
		} catch (UnsupportedLookAndFeelException ex1) {
			System.err.println("Unsupported LookAndFeel: " + lnfName);
		} catch (ClassNotFoundException ex2) {
			System.err.println("LookAndFeel class not found: " + lnfName);
		} catch (InstantiationException ex3) {
			System.err.println("Could not load LookAndFeel: " + lnfName);
		} catch (IllegalAccessException ex4) {
			System.err.println("Cannot use LookAndFeel: " + lnfName);
		}
	}
	
}
